$regfile = "m161def.dat"
$baud = 38400
$crystal = 8000000
Config I2cdelay = 0
Config Sda = Portc.6
Config Scl = Portc.7
Config Debounce = 300
Config Rc5 = Portd.2
Config Porta = &B11111111
Config Pinc.2 = Input
Config Pinc.3 = Input
Config Pinc.4 = Input
Config Pinc.5 = Input
Config Portb = Output
Config Portd = &B11111011
Config Spi = Soft , Din = Portb.0 , Dout = Portb.4 , Ss = None , Clock = Portb.1


'DEKLARACJE ZMIENNYCH***********************************************************
Dim Keyread As Byte
Dim I As Byte
Dim Tm As Byte , Czas As Byte
Dim S As Byte , M As Byte , H As Byte , D As Byte , Month As Byte
Dim S1 As String * 2
Dim M1 As String * 2
Dim H1 As String * 2
Dim D1 As String * 2
Dim Month1 As String * 2
Dim X As Byte
Dim Nr_rs As Byte , Rs_valu As Byte


Dim Adresw As Byte
Dim Rdac As Byte
Dim Valu As Byte
Dim Valu1 As Byte
Dim Valu2 As Byte
Dim Valu3 As Byte
Dim Valu4 As Byte
Dim Valu5 As Byte
Dim Valu6 As Byte
Dim Valux As String * 3
Dim Adresrc5 As Byte

Dim Yy As Byte , Xx As Byte , Lcdsend As Byte , Lcdx As Byte , Lcdy As Byte
Dim B As Byte
Dim Get_rs As Byte
Const Extcmd = &H21                                         'extended command mode
Const Contrmid = &HC8                                       'LCD contract medium level(after Extcmd)
Const Tempcomp2 = &H06                                      'temperature compensation (after Extcmd)
Const Bias48 = &H13                                         'bias 1:48 for LCD (after Extcmd)
Const Normcmd = &H20                                        'normal command mode
Const Lcdinv = &H0D                                         'inverted LCD screen(after Normcmd)
Const Lcdnorm = &H0C                                        'normal LCD screen(after Normcmd)
Const Lcdxaddr0 = &H80                                      'set X addr of RAM to 0(after Normcmd)
Const Lcdpdown = &H24                                       'LCD in power down mode
Const Lcdact = &H20                                         'LCD in active mode
'Const Lcdblank = &B00001000                                 'display blank
'Const Lcdallon = &B00001001                                 'LCD in active mode

Declare Sub Lcdstart
Declare Sub Lcdcom(byval Nlcdcom As Byte)
Declare Sub Lcdclr
Declare Sub Lcdlocate(byval Lcdx As Byte , Byval Lcdy As Byte)
Declare Sub Lcdprint(byval Lcdx As Byte , Byval Lcdy As Byte , Byval Lcdstr As String)
Declare Sub Lcdpic(byval Lcdx As Byte , Byval Lcdy As Byte , Byval Picwidth As Byte , Byval Pichigh As Byte)

Const Adresw1 = &B01011000                                  'adres do zapisu ukadu AD5242
'Const Adresr1 = &B01011001                                  'adres do odczytu ukadu AD5242
Const Adresw2 = &B01011010                                  'adres do zapisu ukadu AD5242
'Const Adresr2 = &B01011011                                  'adres do odczytu ukadu AD5242
Const Adresw3 = &B01011100                                  'adres do zapisu ukadu AD5242
'Const Adresr3 = &B01011101                                  'adres do odczytu ukadu AD5242
Const Rdac1 = &B00000000
Const Rdac2 = &B10000000
'DEKLARACJA ALIASW*************************************************************
Col1 Alias Portd.7
Col2 Alias Portd.6
Col3 Alias Portd.5
Col4 Alias Portd.4
Col5 Alias Portd.3

Row1 Alias Pinc.0
Row2 Alias Pinc.1
Row3 Alias Pinc.2
Row4 Alias Pinc.3
'*******************************PROGRAM*****************************************
Lcdstart
Lcdpic 0 , 1 , 84 , 4
'x,y,dugo w pikselach,szeroko w rzdach.Jeden rzd to 8 pikseli.
Lcdprint 8 , 5 , "ver.2"
Wait 2
Reset Row1 : Reset Row2 : Reset Row3 : Reset Row4
Gosub Restore_valu
Set Portb.3
'*************************SPRAWDZANIE KLAWIATURY********************************
Key:
Gosub Ust
Do
 Gosub Pilot
 If Keyread <> 255 Then
 Gosub Gotkey
 End If
 Gosub Rs
 If Get_rs <> 0 Then
 Keyread = Get_rs
 Get_rs = 0
 Gosub Gotkey
 End If
Set Col1 : Reset Col2 : Reset Col3 : Reset Col4 : Reset Col5
Keyread = 1 : Debounce Row1 , 1 , Gotkey , Sub
Keyread = 3 : Debounce Row2 , 1 , Gotkey , Sub
Keyread = 5 : Debounce Row3 , 1 , Gotkey , Sub
Keyread = 7 : Debounce Row4 , 1 , Gotkey , Sub
'Waitms 10
Reset Col1 : Set Col2 : Reset Col3 : Reset Col4 : Reset Col5
Keyread = 2 : Debounce Row1 , 1 , Gotkey , Sub
Keyread = 4 : Debounce Row2 , 1 , Gotkey , Sub
Keyread = 6 : Debounce Row3 , 1 , Gotkey , Sub
Keyread = 8 : Debounce Row4 , 1 , Gotkey , Sub
'Waitms 10
Reset Col1 : Reset Col2 : Set Col3 : Reset Col4 : Reset Col5
Keyread = 9 : Debounce Row1 , 1 , Gotkey , Sub
Keyread = 11 : Debounce Row2 , 1 , Gotkey , Sub
'Keyread = 13 : Debounce Row3 , 1 , Gotkey , Sub
'Keyread = 15 : Debounce Row4 , 1 , Gotkey , Sub
'Waitms 10
Reset Col1 : Reset Col2 : Reset Col3 : Set Col4 : Reset Col5
Keyread = 10 : Debounce Row1 , 1 , Gotkey , Sub
Keyread = 12 : Debounce Row2 , 1 , Gotkey , Sub
'Keyread = 14 : Debounce Row3 , 1 , Gotkey , Sub
Keyread = 16 : Debounce Row4 , 1 , Gotkey , Sub
'Waitms 10
Reset Col1 : Reset Col2 : Reset Col3 : Reset Col4 : Set Col5
Keyread = 17 : Debounce Row1 , 1 , Gotkey , Sub
'Keyread = 18 : Debounce Row2 , 1 , Gotkey , Sub
'Keyread = 19 : Debounce Row3 , 1 , Gotkey , Sub
'Keyread = 20 : Debounce Row4 , 1 , Gotkey , Sub
Loop

Gotkey:
If Keyread =< 12 Then
 If Keyread = 1 Then
 Incr Valu1
 Gosub Dane_dla_pot1
 'Gosub Pot
 End If
 If Keyread = 2 Then
 Decr Valu1
 Gosub Dane_dla_pot1
 'Gosub Pot
 End If
 If Keyread = 3 Then
 Incr Valu2
 Gosub Dane_dla_pot2
 'Gosub Pot
 End If
 If Keyread = 4 Then
 Decr Valu2
 Gosub Dane_dla_pot2
 'Gosub Pot
 End If
 If Keyread = 5 Then
 Incr Valu3
 Gosub Dane_dla_pot3
 'Gosub Pot
 End If
 If Keyread = 6 Then
 Decr Valu3
 Gosub Dane_dla_pot3
 'Gosub Pot
 End If
 If Keyread = 7 Then
 Incr Valu4
 Gosub Dane_dla_pot4
 'Gosub Pot
 End If
 If Keyread = 8 Then
 Decr Valu4
 Gosub Dane_dla_pot4
 'Gosub Pot
 End If
 If Keyread = 9 Then
 Incr Valu5
 Gosub Dane_dla_pot5
 'Gosub Pot
 End If
 If Keyread = 10 Then
 Decr Valu5
 Gosub Dane_dla_pot5
 'Gosub Pot
 End If
 If Keyread = 11 Then
 Incr Valu6
 Gosub Dane_dla_pot6
 'Gosub Pot
 End If
 If Keyread = 12 Then
 Decr Valu6
 Gosub Dane_dla_pot6
 'Gosub Pot
 End If
Gosub Pot
End If
'If Keyread = 13 Then
'End If
'If Keyread = 14 Then
'End If
'If Keyread = 15 Then
'End If
If Keyread = 16 Then
Gosub Onoff
End If
If Keyread = 17 Then
Gosub Menu
End If
'If Keyread = 18 Then
'Klaw = 1
'End If
'If Keyread = 19 Then
'Klaw = 2
'End If
'If Keyread = 20 Then
'Klaw = 3
'End If
If Keyread = 21 Then
Gosub Rs_comand
End If
Keyread = 0
Return

'****************klawiatora pomocnicza dla podprogramow*************************
'row1=esc row2=gora row3=dol row4=enter
Klaw:
Keyread = 0
Do
Gosub Pilot
'Gosub Rs
Reset Col1 : Reset Col2 : Reset Col3 : Reset Col4 : Set Col5
Waitms 20
If Row1 = 1 Then
Keyread = 1
End If
Waitms 20
If Row2 = 1 Then
Keyread = 2
End If
Waitms 20
If Row3 = 1 Then
Keyread = 3
End If
Waitms 20
If Row4 = 1 Then
Keyread = 4
End If
If Keyread <> 255 Then
Return
End If
Loop
'****************************Obsuga pilota*************************************
Pilot:
Enable Interrupts
Getrc5(adresrc5 , Keyread)
If Adresrc5 = 0 Then
Keyread = Keyread And &B01111111
End If
Disable Interrupts
Return
'*****************************Obsuga RS232*************************************
Rs:
B = Ischarwaiting()
If B = 1 Then
 Input Get_rs
 End If
Return
'*************************************MENU**************************************
Menu:
X = 1
Do
Select Case Keyread
Case 1 : Gosub Sel1
Case 2 : Incr X
Case 3 : Decr X
Case 4 : Gosub Key
Case Else
End Select
If X >= 4 Then
X = 1
End If
If X = 0 Then
X = 3
End If
Lcdclr
Lcdprint 5 , 0 , "Menu"
Lcdprint 0 , 1 , "Zegar"
Lcdprint 0 , 2 , "Tryb Pracy"
Lcdprint 13 , X , "^"
Gosub Klaw
Loop
Sel1:
Lcdclr
Select Case X
Case 1 : Gosub Ustawienie_godz
Case 2 : Gosub Wtb
Case Else
End Select
Return
'**************************OBSUGA POTENCJOMETRW*******************************
Pot:
I2cstart
   I2cwbyte Adresw                                          'wysanie adresu ukadu
   I2cwbyte Rdac                                            'wybr potencjometru
   I2cwbyte Valu                                            'wysanie wybranej wartoci
I2cstop
Return
'*****************************WYBR TRYBU PERACY********************************
Wtb:
I = 1
Do
If I >= 5 Then
I = 1
End If
'If I = 0 Then
'I = 4
'End If
Lcdclr
Lcdprint 2 , 0 , "Tryb pracy"
Lcdprint 0 , 1 , "Off"
'Waitms 10
Lcdprint 0 , 2 , "Music"
'Waitms 10
Lcdprint 0 , 3 , "Movie"
'Waitms 10
Lcdprint 0 , 4 , "Simulated"
'Waitms 10
Lcdprint 10 , I , "^"

Gosub Klaw
Select Case Keyread
Case 1 : Exit Do
Case 2 : Incr I
Case 3 : Decr I
Case 4 : Return
Case Else
End Select
Loop
Wtb1:
 If I = 1 Then
 Reset Portc.4
 Reset Portc.5
 End If
 If I = 2 Then
 Set Portc.4
 Reset Portc.5
 End If
 If I = 3 Then
 Reset Portc.4
 Set Portc.5
 End If
 If I = 4 Then
 Set Portc.4
 Set Portc.5
 End If
Return

'**********************************ZEGAR****************************************
'*****************************Odczyt czasu**************************************
Gettime:
I2cstart                                                    'generate start
    I2cwbyte 160                                            'write addres of PCF8583
    I2cwbyte 2                                              'select second register
    I2cstart                                                'generate repeated start
    I2cwbyte 161                                            'write address for reading info
    I2crbyte S , Ack                                        'read seconds
    I2crbyte M , Ack                                        'read minutes
    I2crbyte H , Ack                                        'read hours
    I2crbyte D , Ack                                        'read year and days
    I2crbyte Month , Nack                                   'read weekday and month
I2cstop                                                     'generate stop
S = Makedec(s)
M = Makedec(m)
H = Makedec(h)
D = Makedec(d)
Month = Makedec(month)
'Print H ; M ; S ; D ; Month
Gosub Spr
S1 = Str(s)
M1 = Str(m)
H1 = Str(h)
D1 = Str(d)
Month1 = Str(month)
Lcdprint 4 , 1 , "Godzina"
Lcdprint 3 , 2 , H1
Lcdprint 6 , 2 , M1
Lcdprint 9 , 2 , S1
'Lcdprint 0 , 3 , "Dzie"
Lcdprint 5 , 3 , "Data"
Lcdprint 2 , 4 , D1
'Lcdprint 6 , 3 , "Miesic"
Lcdprint 10 , 4 , Month1
Waitms 100
Return
'******************************Ustawienie czasu*********************************
Ustawienie_godz:
Tm = 0                                                      'zmienna pomocnicza. Od niej zaley co bdzie ustawiane.
Do
If Tm = 0 Then
If Czas >= 60 Then                                          'sprawdzenie czy warto minut nie przekroczya 60
Czas = 0                                                    'jeli przekroczono 60 min zmienna czas zostaje wyzerowana
End If
M = Czas                                                    'przepisanie wartoci ze zmiennej czas do m
Lcdprint 8 , 0 , " "                                        'czyszczenie pl wywietlacza na ktrch zostanie wywietlona zmienna m
M1 = Str(m)                                                 'konwertowanie zmiennej typu byte na string
Lcdprint 0 , 0 , "Minuta"                                   'wywietlemnie napisu "minuta"
Lcdprint 7 , 0 , M1                                         'wywietlenie aktualnej wartoci
End If

If Tm = 1 Then
If Czas >= 24 Then
Czas = 0
End If
H = Czas
Lcdprint 9 , 1 , " "
H1 = Str(h)
Lcdprint 0 , 1 , "Godzina"
Lcdprint 8 , 1 , H1
End If

If Tm = 2 Then
If Czas >= 32 Then
Czas = 1
End If
D = Czas
Lcdprint 7 , 2 , " "
D1 = Str(d)
Lcdprint 0 , 2 , "Dzie"
Lcdprint 6 , 2 , D1
End If

If Tm = 3 Then
If Czas >= 13 Then
Czas = 1
End If
Month = Czas
Lcdprint 9 , 3 , " "
Month1 = Str(month)
Lcdprint 0 , 3 , "Miesic"
Lcdprint 8 , 3 , Month1
End If

If Tm = 4 Then                                              'jeli zmienna Tm jest rwna 4 wtedy program
Exit Do                                                     'wychodzi z ptli i zapisuje wybrane wartoci
End If
Gosub Klaw
Select Case Keyread                                         'rozpoznanie wybranego klawisza
Case 1 : Incr Tm                                            'jeli wcinito 17 zatwierdzamy dany wybr
Case 2 : Incr Czas                                          'zrikszamy warto
Case 3 : Decr Czas                                          'zmniejszanmy warto
Case 4 : Return                                             'wychodzimy z ustawiania czasu
Case Else
End Select
Loop
S = 0
M = Makebcd(m)
H = Makebcd(h)
D = Makebcd(d)
Month = Makebcd(month)
I2cstart
    I2cwbyte 160
    I2cwbyte 0
    I2cwbyte 8
    I2cstart
    I2cwbyte 160
    I2cwbyte 2
    I2cwbyte S
    I2cwbyte M
    I2cwbyte H
    I2cwbyte D
    I2cwbyte Month
I2cstop
Gosub Key                                                   'powrt do sprawdzania klawiatury

'*********************Wywietlanie nazw potencjometrw**************************
Ust:
Lcdclr
Lcdprint 0 , 0 , "Vol. Center"
Lcdprint 0 , 1 , "Volum"
Lcdprint 0 , 2 , "Balans"
Lcdprint 0 , 3 , "Bass"
Lcdprint 0 , 4 , "Treble"
Lcdprint 0 , 5 , "Efect"
Gosub Dane_dla_pot1
Gosub Dane_dla_pot2
Gosub Dane_dla_pot3
Gosub Dane_dla_pot4
Gosub Dane_dla_pot5
Gosub Dane_dla_pot6
Return

Dane_dla_pot1:
Adresw = Adresw1
Rdac = Rdac1
Valu = Valu1
'Name = "Vol. Center"
Lcdprint 12 , 0 , "  "
Valux = Str(valu1)
Lcdprint 11 , 0 , Valux
Return
Dane_dla_pot2:
Adresw = Adresw1
Rdac = Rdac2
Valu = Valu2
'Name = "Volum"
Lcdprint 12 , 1 , "  "
Valux = Str(valu2)
Lcdprint 11 , 1 , Valux
Return
Dane_dla_pot3:
Adresw = Adresw2
Rdac = Rdac1
Valu = Valu3
'Name = "Balans"
Lcdprint 12 , 2 , "  "
Valux = Str(valu3)
Lcdprint 11 , 2 , Valux
Return
Dane_dla_pot4:
Adresw = Adresw2
Rdac = Rdac2
Valu = Valu4
'Name = "Bass"
Lcdprint 12 , 3 , "  "
Valux = Str(valu4)
Lcdprint 11 , 3 , Valux
Return
Dane_dla_pot5:
Adresw = Adresw3
Rdac = Rdac1
Valu = Valu5
'Name = "Treble"
Lcdprint 12 , 4 , "  "
Valux = Str(valu5)
Lcdprint 11 , 4 , Valux
Return
Dane_dla_pot6:
Adresw = Adresw3
Rdac = Rdac2
Valu = Valu6
'Name = "Efect"
Lcdprint 12 , 5 , "  "
Valux = Str(valu6)
Lcdprint 11 , 5 , Valux
Return
'******************Sprawdzanie poprawnoci danych na LCD************************
Spr:
If S = 0 Then
Lcdprint 10 , 2 , " "
End If
If M = 0 Then
Lcdprint 7 , 2 , " "
End If
If H = 0 Then
Lcdprint 4 , 2 , " "
End If
If D = 1 Then
Lcdprint 6 , 4 , " "
End If
If Month = 1 Then
Lcdprint 9 , 4 , " "
End If
Return
'****************Przywracanie ostatnich wartoci po wczeniu*******************
Restore_valu:
Readeeprom Valu1 , 506
Gosub Dane_dla_pot1
Gosub Pot
Readeeprom Valu2 , 507
Gosub Dane_dla_pot2
Gosub Pot
Readeeprom Valu3 , 508
Gosub Dane_dla_pot3
Gosub Pot
Readeeprom Valu4 , 509
Gosub Dane_dla_pot4
Gosub Pot
Readeeprom Valu5 , 510
Gosub Dane_dla_pot5
Gosub Pot
Readeeprom Valu6 , 511
Gosub Dane_dla_pot6
Gosub Pot
Readeeprom I , 505
Gosub Wtb1
Return
'**********************************wprowadzanie danych przez rs*****************
Rs_comand:
Input Nr_rs                                                 'wybr potencjometru
Input Rs_valu                                               'wprowadzenie wartoci do wysania do potencjometru
If Nr_rs = 1 Then                                           'jeli nr_rs=1 wybrano 1 potencjometr
Valu1 = Rs_valu                                             'przypisanie wartoci wprowadzonej przez uart do zmiennej 1 pot.
Gosub Dane_dla_pot1                                         'skok do podprogramu ustawiajcego parametry dla danego pot.
End If
If Nr_rs = 2 Then
Valu2 = Rs_valu
Gosub Dane_dla_pot2
End If
If Nr_rs = 3 Then
Valu3 = Rs_valu
Gosub Dane_dla_pot3
End If
If Nr_rs = 4 Then
Valu4 = Rs_valu
Gosub Dane_dla_pot4
End If
If Nr_rs = 5 Then
Valu5 = Rs_valu
Gosub Dane_dla_pot5
End If
If Nr_rs = 6 Then
Valu6 = Rs_valu
Gosub Dane_dla_pot6
End If
Gosub Pot                                                   'skok do podprogramu zapisujceko wybrane wartoci
Nr_rs = 0
Rs_valu = 0
Keyread = 0
Gosub Key
'***************************Wczanie dekodera *********************************
Onoff:
Lcdclr
Lcdprint 0 , 0 , "Dekoder"
Lcdprint 5 , 1 , "wyczony"
'Print "Dekoder" , "wyaczony"
Wait 2
Lcdclr
Writeeeprom I , 505
Writeeeprom Valu1 , 506
Writeeeprom Valu2 , 507
Writeeeprom Valu3 , 508
Writeeeprom Valu4 , 509
Writeeeprom Valu5 , 510
Writeeeprom Valu6 , 511
Set Col1 : Set Col2 : Set Col3 : Set Col4 : Set Col5
Reset Portb.3
Do
Gosub Gettime
Gosub Pilot
Loop Until Row4 = 1
Set Portb.3
Gosub Ust
Gosub Key
End
'************************************KONIEC*************************************
'*****************************obsluga wyswietlacza******************************
'******************************* Tcmd(Tlcdcmd) *********************************
Sub Lcdstart
Spiinit
Reset Portb.6                                               'dostp do lcd
Reset Portb.7                                               'reset lcd
Waitms 2
Set Portb.7
Lcdcom Extcmd
Lcdcom Contrmid
Lcdcom Tempcomp2
Lcdcom Bias48
Lcdcom Normcmd
Lcdcom Lcdnorm
Lcdclr
End Sub
'*********************************Lcdcom****************************************
Sub Lcdcom(byval Nlcdcom As Byte)
Reset Portb.5                                               'przejcie do trybu komend
Spiout Nlcdcom , 1
Set Portb.5                                                 'przejcie do trybu danych
End Sub
'************************************lcdclr*********************************START
Sub Lcdclr
Local Lclr As Word
Lcdlocate 0 , 0                                             'ustawienie kursora na pozycji 0,0
Lcdsend = 0                                                 'warto ktra zostanie wysana do lcd
For Lclr = 0 To 503                                         'wygaszanie wszystkich pikseli
  Spiout Lcdsend , 1                                        'wysanie danych
Next
End Sub
'***************************** Tgphloc(Txglc , Tyglc) ***********************START
Sub Lcdlocate(lcdx As Byte , Lcdy As Byte)
Reset Portb.5                                               'przejcie do trybu danych
Lcdsend = Lcdy + &H40                                       'ustawienie adresu w pamici (poz Y)
Spiout Lcdsend , 1
Lcdsend = Lcdx * &H06                                       'ustawienie adresu w pamici (poz X)
Lcdsend = Lcdsend + &H80
Spiout Lcdsend , 1
Set Portb.5                                                 'przejcie do trybu danych
End Sub
'********************************* lcdprint(Tstring) ************************START
Sub Lcdprint(byval Lcdx As Byte , Byval Lcdy As Byte , Byval Lcdstr As String)
Local Eepadr As Word , Eepadr2 As Word , T As Byte , Tchr As String * 1
Lcdlocate Lcdx , Lcdy
T = 0
For Xx = 1 To Len(lcdstr)
 Tchr = Mid(lcdstr , Xx , 1)
 Select Case Tchr
  Case " " : Eepadr = 0
  Case "a" : Eepadr = 6
  Case "b" : Eepadr = 12
  Case "c" : Eepadr = 18
  Case "d" : Eepadr = 24
  Case "e" : Eepadr = 30
  Case "f" : Eepadr = 36
  Case "g" : Eepadr = 42
  Case "h" : Eepadr = 48
  Case "i" : Eepadr = 54
  Case "j" : Eepadr = 60
  Case "k" : Eepadr = 66
  Case "l" : Eepadr = 72
  Case "m" : Eepadr = 78
  Case "n" : Eepadr = 84
  Case "o" : Eepadr = 90
  Case "p" : Eepadr = 96
  Case "q" : Eepadr = 102
  Case "r" : Eepadr = 108
  Case "s" : Eepadr = 114
  Case "t" : Eepadr = 120
  Case "u" : Eepadr = 126
  Case "v" : Eepadr = 132
  Case "w" : Eepadr = 138
  Case "x" : Eepadr = 144
  Case "y" : Eepadr = 150
  Case "z" : Eepadr = 156
  Case "A" : Eepadr = 162
  Case "B" : Eepadr = 168
  Case "C" : Eepadr = 174
  Case "D" : Eepadr = 180
  Case "E" : Eepadr = 186
  Case "F" : Eepadr = 192
  Case "G" : Eepadr = 198
  Case "H" : Eepadr = 204
  Case "I" : Eepadr = 210
  Case "J" : Eepadr = 216
  Case "K" : Eepadr = 222
  Case "L" : Eepadr = 228
  Case "M" : Eepadr = 234
  Case "N" : Eepadr = 240
  Case "O" : Eepadr = 246
  Case "P" : Eepadr = 252
  Case "Q" : Eepadr = 258
  Case "R" : Eepadr = 264
  Case "S" : Eepadr = 270
  Case "T" : Eepadr = 276
  Case "U" : Eepadr = 282
  Case "V" : Eepadr = 288
  Case "W" : Eepadr = 294
  Case "X" : Eepadr = 300
  Case "Y" : Eepadr = 306
  Case "Z" : Eepadr = 312
  Case "0" : Eepadr = 318
  Case "1" : Eepadr = 324
  Case "2" : Eepadr = 330
  Case "3" : Eepadr = 336
  Case "4" : Eepadr = 342
  Case "5" : Eepadr = 348
  Case "6" : Eepadr = 354
  Case "7" : Eepadr = 360
  Case "8" : Eepadr = 366
  Case "9" : Eepadr = 372
  Case "" : Eepadr = 378
  Case "" : Eepadr = 384
  Case "" : Eepadr = 390
  Case "" : Eepadr = 396
  Case "" : Eepadr = 402
  Case "" : Eepadr = 408
  Case "" : Eepadr = 414
  Case "" : Eepadr = 420
  Case "" : Eepadr = 426
  Case "" : Eepadr = 432
  Case "" : Eepadr = 438
  Case "" : Eepadr = 444
  Case "" : Eepadr = 450
  Case "" : Eepadr = 456
  Case "" : Eepadr = 462
  Case "" : Eepadr = 468
  Case "" : Eepadr = 474
  Case "" : Eepadr = 480
  Case ":" : Eepadr = 486
  Case "^" : Eepadr = 492
  Case Else : Goto Exit_case
 End Select
 Set Portb.5
 For T = 0 To 5
  Eepadr2 = Eepadr + T
  Readeeprom Lcdsend , Eepadr2
  Spiout Lcdsend , 1
 Next T
Exit_case:
Next Xx
End Sub

'************************************ Tshowpic *****************************START
Sub Lcdpic(byval Lcdx As Byte , Byval Lcdy As Byte , Byval Picwidth As Byte , Byval Pichigh As Byte)
Local Rb As Byte , Adr As Byte , Adrw As Byte , Adrr As Byte
Lcdlocate Lcdx , Lcdy
Adrw = 168
Adrr = 169
Adr = 0
'I2cinit
For Yy = 1 To Pichigh
For Xx = 1 To Picwidth
I2cstart
   I2cwbyte Adrw
   I2cwbyte Adr
   I2cstart
   I2cwbyte Adrr
   I2crbyte Rb , Nack
   I2cstop
   Spiout Rb , 1
  Incr Adr
 If Adr = 255 Then
 Adrw = Adrw + 2
 Adrr = Adrr + 2
 End If
 Next
  Incr Lcdy
 Lcdlocate Lcdx , Lcdy
Next
End Sub

'************************************* D A T A *****************************START
$eeprom
Data &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H20 , &H54 , &H54 , &H54 , &H78 , &H00 , &H3F , &H48 , &H48 , &H48,
Data &H30 , &H00 , &H38 , &H44 , &H44 , &H44 , &H28 , &H00 , &H30 , &H48 , &H48 , &H48 , &H7F , &H00 , &H38 , &H54,
Data &H54 , &H54 , &H18 , &H00 , &H00 , &H04 , &H7E , &H05 , &H00 , &H00 , &H18 , &HA4 , &HA4 , &HA4 , &H78 , &H00,
Data &H7F , &H08 , &H04 , &H04 , &H78 , &H00 , &H00 , &H44 , &H7D , &H40 , &H00 , &H00 , &H00 , &H40 , &H44 , &H3D,
Data &H00 , &H00 , &H7F , &H20 , &H10 , &H28 , &H44 , &H00 , &H00 , &H41 , &H7F , &H40 , &H00 , &H00 , &H7C , &H04,
Data &H18 , &H04 , &H7C , &H00 , &H7C , &H08 , &H04 , &H04 , &H78 , &H00 , &H38 , &H44 , &H44 , &H44 , &H38 , &H00,
Data &HFC , &H14 , &H14 , &H14 , &H08 , &H00 , &H08 , &H14 , &H14 , &H14 , &HFC , &H00 , &H7C , &H04 , &H04 , &H08,
Data &H00 , &H00 , &H08 , &H54 , &H54 , &H54 , &H20 , &H00 , &H04 , &H3F , &H44 , &H40 , &H00 , &H00 , &H3C , &H40,
Data &H40 , &H40 , &H3C , &H00 , &H1C , &H20 , &H40 , &H20 , &H1C , &H00 , &H3C , &H40 , &H30 , &H40 , &H3C , &H00,
Data &H44 , &H28 , &H10 , &H28 , &H44 , &H00 , &H0C , &H90 , &H90 , &H90 , &H7C , &H00 , &H44 , &H64 , &H54 , &H4C,
Data &H44 , &H00 , &H7C , &H12 , &H11 , &H12 , &H7C , &H00 , &H7F , &H49 , &H49 , &H49 , &H36 , &H00 , &H3E , &H41,
Data &H41 , &H41 , &H22 , &H00 , &H7F , &H41 , &H41 , &H41 , &H3E , &H00 , &H7F , &H49 , &H49 , &H49 , &H41 , &H00,
Data &H7F , &H09 , &H09 , &H09 , &H01 , &H00 , &H3E , &H41 , &H49 , &H49 , &H3A , &H00 , &H7F , &H08 , &H08 , &H08,
Data &H7F , &H00 , &H00 , &H41 , &H7F , &H41 , &H00 , &H00 , &H20 , &H41 , &H41 , &H41 , &H3F , &H00 , &H7F , &H08,
Data &H14 , &H22 , &H41 , &H00 , &H7F , &H40 , &H40 , &H40 , &H40 , &H00 , &H7F , &H02 , &H04 , &H02 , &H7F , &H00,
Data &H7F , &H04 , &H08 , &H10 , &H7F , &H00 , &H3E , &H41 , &H41 , &H41 , &H3E , &H00 , &H7F , &H09 , &H09 , &H09,
Data &H06 , &H00 , &H3E , &H41 , &H51 , &H61 , &H7E , &H00 , &H7F , &H09 , &H19 , &H29 , &H46 , &H00 , &H06 , &H49,
Data &H49 , &H49 , &H30 , &H00 , &H01 , &H01 , &H7F , &H01 , &H01 , &H00 , &H3F , &H40 , &H40 , &H40 , &H3F , &H00,
Data &H1F , &H20 , &H40 , &H20 , &H1F , &H00 , &H7F , &H20 , &H10 , &H20 , &H7F , &H00 , &H63 , &H14 , &H08 , &H14,
Data &H63 , &H00 , &H03 , &H04 , &H78 , &H04 , &H03 , &H00 , &H61 , &H51 , &H49 , &H45 , &H43 , &H00 , &H3E , &H51,
Data &H49 , &H45 , &H3E , &H00 , &H00 , &H42 , &H7F , &H40 , &H00 , &H00 , &H42 , &H61 , &H51 , &H49 , &H46 , &H00,
Data &H22 , &H41 , &H49 , &H49 , &H36 , &H00 , &H18 , &H14 , &H12 , &H7F , &H10 , &H00 , &H27 , &H45 , &H45 , &H45,
Data &H39 , &H00 , &H3E , &H49 , &H49 , &H49 , &H32 , &H00 , &H61 , &H11 , &H09 , &H05 , &H03 , &H00 , &H36 , &H49,
Data &H49 , &H49 , &H36 , &H00 , &H26 , &H49 , &H49 , &H49 , &H3E , &H00 , &H20 , &H54 , &H54 , &HD4 , &H78 , &H00,
Data &H38 , &H44 , &H46 , &H45 , &H28 , &H00 , &H38 , &H54 , &H54 , &HD4 , &H18 , &H00 , &H00 , &H49 , &H7F , &H44,
Data &H00 , &H00 , &H7C , &H08 , &H06 , &H05 , &H78 , &H00 , &H38 , &H44 , &H46 , &H45 , &H38 , &H00 , &H08 , &H54,
Data &H56 , &H55 , &H20 , &H00 , &H44 , &H64 , &H56 , &H4D , &H44 , &H00 , &H44 , &H64 , &H55 , &H4C , &H44 , &H00,
Data &H7C , &H12 , &H11 , &H92 , &H7C , &H00 , &H3C , &H42 , &H46 , &H43 , &H24 , &H00 , &H7F , &H49 , &H49 , &HC9,
Data &H41 , &H00 , &H10 , &H7F , &H48 , &H44 , &H40 , &H00 , &H7E , &H04 , &H0A , &H11 , &H7C , &H00 , &H3C , &H42,
Data &H46 , &H43 , &H3C , &H00 , &H04 , &H4A , &H4B , &H4A , &H30 , &H00 , &H62 , &H56 , &H4B , &H46 , &H42 , &H00,
Data &H61 , &H59 , &H49 , &H4D , &H43 , &H00 , &H00 , &H00 , &H66 , &H66 , &H00 , &H00 , &H18 , &H3C , &H7E , &H18,
Data &H18 , &H18 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H01 , &H00 , &H32 , &H80 , &H80 , &H80 , &H80